
/****************************************************************************
*                                                                           *
*   Communication subroutines necessary in the simulator and transfer       *
*   program modules                                                         *
*   Version 0.6                                                             *
*   1.6.94             (C) Petra Roosen                                     *
*                                                                           *
****************************************************************************/

bool empfange()
{
  int i, gelesen;
  char aktFile[250];


  sprintf(aktFile, "%so2s.msg", Transdir);

  do    /** wait for the existence of the message file **/
  {
#ifdef UNIX
    sleep( (int)(optidelay/1000) );
#else
    _sleep2(optidelay);
#endif
    flagfile = fopen(aktFile, "r");
  }
    while (flagfile == NULL);
  fclose(flagfile);
  remove(aktFile);

  sprintf(aktFile, "%so2s.dat", Transdir);

lies_Daten:
#ifdef UNIX
    sleep(sleeptime);
#else
    _sleep2(sleeptime);
#endif
  do
    infile = fopen(aktFile, "r");
    while (infile == NULL);

  fscanf(infile, "%*s %*s %d %*s", &Parazahl);
  if (Parazahl == 0)
    {
      printf("Stop message received from optimizer: simulator dies.\n");
      fclose(infile);
      sleep(5);
      remove(aktFile);
      exit(0);
    }

  for (i=0; i<Parazahl; i++)
  {
    gelesen = fscanf(infile, "%s %lf %lf",
                     Limits[i].Name, &(Indi.koeff[i]), &(Indi.dkoeff[i]) );
    if (gelesen != 3)
      {
        fclose(infile);
        sleeptime += 2;
        goto lies_Daten;
      }
    sleeptime--;
    sleeptime = max(sleeptime, minsleep);
  }
  fscanf(infile, "%*s %d %*s %d %*s %d %*s %d",
         &(Indi.Kennzahl), &(Indi.Mama), &(Indi.Papa), &(Indi.Alter) );
  fclose(infile);

  remove(aktFile);

  return TRUE;
}


bool verschicke()
{
  int  i;
  char aktFile[250];


  sprintf(aktFile, "%ss2o.dat", Transdir);
  outfile = fopen(aktFile, "w");

  if (outfile != NULL)
    {
      fprintf(outfile, "Ergebnis zu Kennzahl %d mit %d Parametern\n\n",
              Indi.Kennzahl, Parazahl);
      for (i=0; i<Parazahl; i++)
      {
        fprintf(outfile, "%s %G %G\n",
                Limits[i].Name, Indi.koeff[i], Indi.dkoeff[i]);
      }
      fprintf(outfile, "Mama     %d\n", Indi.Mama);
      fprintf(outfile, "Papa     %d\n", Indi.Papa);
      fprintf(outfile, "Alter    %d\n", Indi.Alter);
      fprintf(outfile, "Ergebnis %G\n", Indi.Ergebnis);
      fclose(outfile);
      sprintf(aktFile, "%ss2o.msg", Transdir);
      flagfile = fopen(aktFile, "w");
      fclose(flagfile);

      return TRUE;
                }
                else
                        return FALSE;
}


