/****************************************************************************
*                                                                           *
*   simulaton program for the evolutionary optimizer:                       *
*   target function is to be included in this source                        *
*   Version 0.5                                                             *
*   19.4.94            (C) Petra Roosen                                     *
*                                                                           *
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifdef UNIX
  #include <unistd.h>
#endif

#include "epo.h"


/**** global variables: ****/

Paraset Indi;
int     Parazahl, Runde;
Iniset  Limits[5];
FILE    *infile, *outfile, *flagfile;
char    Transdir[250];
int     sleeptime=1;
int     optidelay;        /* Wartezeit in Empfange-Schleife */


/**** function prototypes: ****/

void    main(void);
void    init(void);
void    rechne(void);

#include "eposim.c"

/**************************************************************************/
/**************************************************************************/
/******************* Begin of target function determination ***************/

void rechne()  /* Example: Minimal fct. value of a hyper-paraboloid */
{
  double  Ergebnis;
  int     i;


  Ergebnis = 0;
  for (i=0; i<Parazahl; i++)
  {
    Ergebnis += Indi.koeff[i] * Indi.koeff[i];
  }

  Indi.Ergebnis = Ergebnis;
}

/******************** End of target function determination *****************/
/***************************************************************************/
/***************************************************************************/

void main()
{
  bool klappt;

  init();               /* for transfer directory determination only */

  forever
  {
    Runde++;
    klappt = empfange();
    rechne();
    printf("%d. simulator result: %G,          sleep time: %d\n",
           Runde, Indi.Ergebnis, sleeptime);
    klappt = verschicke();
  }
}


void init()
{
  FILE    *fp;
  char    dummy[250];

  printf("\n\n");
  printf("  **************************************************\n");
  printf("  * Simulator module for co-operation with the     *\n");
  printf("  * evolutionary parameter optimizer               *\n");
  printf("  * for general optimization problems              *\n");
  printf("  *                                                *\n");
  printf("  * Shareware version 0.5    (C)3/94  Petra Roosen *\n");
  printf("  **************************************************\n\n");


  /******* Einlesen des Transfer-Directories ******/
#ifdef UNIX
  if ( (fp=fopen("strateg.unx","r")) )
#else
  if ( (fp=fopen("strateg.os2","r")) )
#endif
    {
      fscanf(fp, "%s", dummy);
      if ( strcmp(dummy, Version) )
      {
        printf("\007\007Wrong initialization file at the identification header!\n");
        sleep(5);
        exit(0);
      }
      fscanf(fp, "%*s");
      fscanf(fp, "%*s %*s");
      fscanf(fp, "%s %d", dummy, &optidelay);
      if ( strcmp(dummy, "optidelay") )
        {
          printf("\007Faulty initialization at \"optidelay\"!\n");
          sleep(5);
          exit(0);
        }
      fscanf(fp, "%*s %*d");
      fscanf(fp, "%*s %*d");
      fscanf(fp, "%*s %*d");
      fscanf(fp, "%*s %*d");
      fscanf(fp, "%*s %*s");
      fscanf(fp, "%*s %*s");
      fscanf(fp, "%s %s", dummy, Transdir);
      if ( strcmp(dummy, "transfer_dir") )
      {
        printf("\007Faulty initialization file at \"transfer_dir\"!\n");
        sleep(5);
        exit(0);
      }
      fclose(fp);
    }
}


